<template>
  <div class="container-fluid w-100 h-100 bg-light m-0" id="side-info">
    <div class="row">
      <div class="container-fluid mt-4">
        <div class="row">
          <div class="col">
            <h3>Informations</h3>
          </div>
        </div>
        <hr class="dropdown-divider mb-4" />

        <div class="row">
          <div class="col">
            <h5>Informations Coureur</h5>
          </div>
        </div>
        <div class="row text-start">
          <div class="col">
            <span class="d-inline"
              ><p class="d-inline fw-bolder me-2">Prénom:</p>
              <p class="d-inline">{{ athlete.first_name }}</p></span
            >
          </div>
        </div>
        <div class="row text-start">
          <div class="col">
            <span class="d-inline"
              ><p class="d-inline fw-bolder me-2">Prenom:</p>
              <p class="d-inline">{{ athlete.last_name }}</p></span
            >
          </div>
        </div>
        <div class="row text-start">
          <div class="col">
            <span class="d-inline"
              ><p class="d-inline fw-bolder me-2">Date de naissance:</p>
              <p class="d-inline">{{ athlete.birthdate }}</p></span
            >
          </div>
        </div>
        <div class="row text-start">
          <div class="col">
            <span class="d-inline"
              ><p class="d-inline fw-bolder me-2">Email:</p>
              <p class="d-inline">{{ athlete.email }}</p></span
            >
          </div>
        </div>
        <div class="row text-start">
          <div class="col">
            <span class="d-inline"
              ><p class="d-inline fw-bolder me-2">Téléphone:</p>
              <p class="d-inline">{{ athlete.phone }}</p></span
            >
          </div>
        </div>
      </div>
      <hr class="dropdown-divider my-4" />
      <div class="row">
        <div class="col">
          <h5>Informations Course</h5>
        </div>
      </div>
      <div class="row text-start">
        <div class="col">
          <span class="d-inline"
            ><p class="d-inline fw-bolder me-2">Course:</p>

            <p class="d-inline">{{ athlete.team.category.label }}</p></span
          >
        </div>
      </div>

      <hr class="dropdown-divider my-4" />
      <div class="row">
        <div class="col">
          <h5>Informations Certificat</h5>
        </div>
      </div>

      <div class="row text-start">
        <div class="col">
          <span class="d-inline"
            ><p class="d-inline fw-bolder">Status:</p>
            <span
              v-if="athlete.certificate.status === 0"
              class="badge ms-2 bg-secondary"
              >Abscent</span
            >
            <span
              v-else-if="athlete.certificate.status === 1"
              class="badge ms-2 bg-success"
              >Validé</span
            >
            <span
              v-else-if="athlete.certificate.status === 2"
              class="badge ms-2 bg-danger"
              >Rejeté</span
            >
            <span v-else class="badge ms-2 bg-warning">A verifié</span>
          </span>
        </div>
      </div>

      <div class="row mt-5">
        <div class="col">
          <button class="btn btn-success" @click="validateCertificate">
            Valider
          </button>
        </div>
        <div class="col">
          <button class="btn btn-danger" @click="rejectCertificate">
            Rejeté
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import axios from "axios";

export interface Certificate {
  id: number;
  status: number;
}

export interface Category {
  id: number;
  label: string;
}

export interface Team {
  id: number;
  name: string;
  category: Category;
}

export interface Athlete {
  id: number;
  first_name: string;
  last_name: string;
  birthdate: string;
  email: string;
  phone: string;
  team: Team;
  certificate: Certificate;
}

export default defineComponent({
  props: {
    athleteId: Number,
  },
  data() {
    return {
      athlete: {
        id: null,
        first_name: null,
        last_name: null,
        birthdate: null,
        email: null,
        phone: null,
        team: {
          name: null,
          category: {
            label: null,
          },
        },
        certificate: {
          id: null,
          status: null,
        },
      },
    };
  },
  methods: {
    validateCertificate() {
      console.log("Validating certificate...");
      axios
        .post("certificates/" + this.athlete.certificate.id + "/validate/")
        .then((response) => {
          console.log(response);
          this.reloadInfo();
        });
    },
    rejectCertificate() {
      console.log("Reject certificate...");
      axios
        .post("certificates/" + this.athlete.certificate.id + "/reject/")
        .then((response) => {
          console.log(response);
          this.reloadInfo();
        });
    },
    reloadInfo() {
      axios
        .get("athletes/" + this.athleteId)
        .then((response) => (this.athlete = response.data));
    },
  },
  watch: {
    athleteId() {
      console.log(this.athleteId);
      this.reloadInfo();
    },
  },
});
</script>
